typedef struct _GdomeDOMString GdomeDOMString;
typedef int GdomeBoolean;

struct _GdomeDOMString {
  void (*unref) (GdomeDOMString *self);
  char *str;
};

typedef struct _GdomeNode GdomeNode;
typedef struct _GdomeAttr GdomeAttr;
typedef struct _GdomeCharacterData GdomeCharacterData;
typedef struct _GdomeText GdomeText;
typedef struct _GdomeCDATASection GdomeCDATASection;
typedef struct _GdomeComment GdomeComment;
typedef struct _GdomeDOMImplementation GdomeDOMImplementation;
typedef struct _GdomeDocument GdomeDocument;
typedef struct _GdomeDocumentFragment GdomeDocumentFragment;
typedef struct _GdomeDocumentType GdomeDocumentType;
typedef struct _GdomeElement GdomeElement;
typedef struct _GdomeEntity GdomeEntity;
typedef struct _GdomeEntityReference GdomeEntityReference;
typedef struct _GdomeNamedNodeMap GdomeNamedNodeMap;
typedef struct _GdomeNodeList GdomeNodeList;
typedef struct _GdomeNotation GdomeNotation;
typedef struct _GdomeParser GdomeParser;
typedef struct _GdomeProcessingInstruction GdomeProcessingInstruction;

typedef struct _GdomeNodeVtab GdomeNodeVtab;
typedef struct _GdomeAttrVtab GdomeAttrVtab;
typedef struct _GdomeCharacterDataVtab GdomeCharacterDataVtab;
typedef struct _GdomeTextVtab GdomeTextVtab;
typedef struct _GdomeCDATASectionVtab GdomeCDATASectionVtab;
typedef struct _GdomeCommentVtab GdomeCommentVtab;
typedef struct _GdomeDOMImplementationVtab GdomeDOMImplementationVtab;
typedef struct _GdomeDocumentVtab GdomeDocumentVtab;
typedef struct _GdomeDocumentFragmentVtab GdomeDocumentFragmentVtab;
typedef struct _GdomeDocumentTypeVtab GdomeDocumentTypeVtab;
typedef struct _GdomeElementVtab GdomeElementVtab;
typedef struct _GdomeEntityVtab GdomeEntityVtab;
typedef struct _GdomeEntityReferenceVtab GdomeEntityReferenceVtab;
typedef struct _GdomeNamedNodeMapVtab GdomeNamedNodeMapVtab;
typedef struct _GdomeNodeListVtab GdomeNodeListVtab;
typedef struct _GdomeNotationVtab GdomeNotationVtab;
typedef struct _GdomeParserVtab GdomeParserVtab;
typedef struct _GdomeProcessingInstructionVtab GdomeProcessingInstructionVtab;

#define GDOME_ELEMENT_NODE 1
#define GDOME_ATTRIBUTE_NODE 2
#define GDOME_TEXT_NODE 3
#define GDOME_CDATA_SECTION_NODE 4
#define GDOME_ENTITY_REFERENCE_NODE 5
#define GDOME_ENTITY_NODE 6
#define GDOME_PROCESSING_INSTRUCTION_NODE 7
#define GDOME_COMMENT_NODE 8
#define GDOME_DOCUMENT_NODE 9
#define GDOME_DOCUMENT_TYPE_NODE 10
#define GDOME_DOCUMENT_FRAGMENT_NODE 11
#define GDOME_NOTATION_NODE 12

struct _GdomeNode {
  GdomeNodeVtab *vtab;
};

struct _GdomeAttr {
  GdomeAttrVtab *vtab;
};

struct _GdomeCharacterData {
  GdomeCharacterDataVtab *vtab;
};

struct _GdomeText {
  GdomeTextVtab *vtab;
};

struct _GdomeCDATASection {
  GdomeCDATASectionVtab *vtab;
};

struct _GdomeComment {
  GdomeCommentVtab *vtab;
};

struct _GdomeDOMImplementation {
  GdomeDOMImplementationVtab *vtab;
};

struct _GdomeDocument {
  GdomeDocumentVtab *vtab;
};

struct _GdomeDocumentFragment {
  GdomeDocumentFragmentVtab *vtab;
};

struct _GdomeDocumentType {
  GdomeDocumentTypeVtab *vtab;
};

struct _GdomeElement {
  GdomeElementVtab *vtab;
};

struct _GdomeEntity {
  GdomeEntityVtab *vtab;
};

struct _GdomeEntityReference {
  GdomeEntityReferenceVtab *vtab;
};

struct _GdomeNamedNodeMap {
  GdomeNamedNodeMapVtab *vtab;
};

struct _GdomeNodeList {
  GdomeNodeListVtab *vtab;
};

struct _GdomeNotation {
  GdomeNotationVtab *vtab;
};

struct _GdomeParser {
  GdomeParserVtab *vtab;
};

struct _GdomeProcessingInstruction {
  GdomeProcessingInstructionVtab *vtab;
};


struct _GdomeNodeVtab {
  void (*unref) (GdomeNode *self);
  GdomeDOMString *(*nodeName) (GdomeNode *self);
  GdomeDOMString *(*nodeValue) (GdomeNode *self);
  void (*set_nodeValue) (GdomeNode *self, GdomeDOMString *nodeValue);
  unsigned short (*nodeType) (GdomeNode *self);
  GdomeNode *(*parentNode) (GdomeNode *self);
  GdomeNodeList *(*childNodes) (GdomeNode *self);
  GdomeNode *(*firstChild) (GdomeNode *self);
  GdomeNode *(*lastChild) (GdomeNode *self);
  GdomeNode *(*previousSibling) (GdomeNode *self);
  GdomeNode *(*nextSibling) (GdomeNode *self);
  GdomeNamedNodeMap *(*attributes) (GdomeNode *self);
  GdomeDocument *(*ownerDocument) (GdomeNode *self);
  GdomeNode *(*insertBefore) (GdomeNode *self, GdomeNode *newChild, GdomeNode *refChild);
  GdomeNode *(*replaceChild) (GdomeNode *self, GdomeNode *newChild, GdomeNode *oldChild);
  GdomeNode *(*removeChild) (GdomeNode *self, GdomeNode *oldChild);
  GdomeNode *(*appendChild) (GdomeNode *self, GdomeNode *newChild);
  GdomeBoolean (*hasChildNodes) (GdomeNode *self);
  GdomeNode *(*cloneNode) (GdomeNode *self, GdomeBoolean deep);
};

struct _GdomeAttrVtab {
  GdomeNodeVtab super;
  GdomeDOMString *(*name) (GdomeAttr *self);
  GdomeBoolean (*specified) (GdomeAttr *self);
  GdomeDOMString *(*value) (GdomeAttr *self);
  void (*set_value) (GdomeAttr *self, GdomeDOMString *value);
};

struct _GdomeCharacterDataVtab {
  GdomeNodeVtab super;
  GdomeDOMString *(*data) (GdomeCharacterData *self);
  void (*set_data) (GdomeCharacterData *self, GdomeDOMString *data);
  unsigned long (*length) (GdomeCharacterData *self);
  GdomeDOMString *(*substringData) (GdomeCharacterData *self, unsigned long offset, unsigned long count);
  void (*appendData) (GdomeCharacterData *self, GdomeDOMString *arg);
  void (*insertData) (GdomeCharacterData *self, unsigned long offset, GdomeDOMString *arg);
  void (*deleteData) (GdomeCharacterData *self, unsigned long offset, unsigned long count);
  void (*replaceData) (GdomeCharacterData *self, unsigned long offset, unsigned long count, GdomeDOMString *arg);
};

struct _GdomeTextVtab {
  GdomeCharacterDataVtab super;
  GdomeText *(*splitText) (GdomeText *self, unsigned long offset);
};

struct _GdomeCDATASectionVtab {
  GdomeTextVtab super;
};

struct _GdomeCommentVtab {
  GdomeCharacterDataVtab super;
};

struct _GdomeDOMImplementationVtab {
  void (*unref) (GdomeDOMImplementation *self);
  GdomeBoolean (*hasFeature) (GdomeDOMImplementation *self, GdomeDOMString *feature, GdomeDOMString *version);
};

struct _GdomeDocumentVtab {
  GdomeNodeVtab super;
  GdomeDocumentType *(*doctype) (GdomeDocument *self);
  GdomeDOMImplementation *(*implementation) (GdomeDocument *self);
  GdomeElement *(*documentElement) (GdomeDocument *self);
  GdomeElement *(*createElement) (GdomeDocument *self, GdomeDOMString *tagName);
  GdomeDocumentFragment *(*createDocumentFragment) (GdomeDocument *self);
  GdomeText *(*createTextNode) (GdomeDocument *self, GdomeDOMString *data);
  GdomeComment *(*createComment) (GdomeDocument *self, GdomeDOMString *data);
  GdomeCDATASection *(*createCDATASection) (GdomeDocument *self, GdomeDOMString *data);
  GdomeProcessingInstruction *(*createProcessingInstruction) (GdomeDocument *self, GdomeDOMString *target, GdomeDOMString *data);
  GdomeAttr *(*createAttribute) (GdomeDocument *self, GdomeDOMString *name);
  GdomeEntityReference *(*createEntityReference) (GdomeDocument *self, GdomeDOMString *name);
  GdomeNodeList *(*getElementsByTagName) (GdomeDocument *self, GdomeDOMString *tagname);
};

struct _GdomeDocumentFragmentVtab {
  GdomeNodeVtab super;
};

struct _GdomeDocumentTypeVtab {
  GdomeNodeVtab super;
  GdomeDOMString *(*name) (GdomeDocumentType *self);
  GdomeNamedNodeMap *(*entities) (GdomeDocumentType *self);
  GdomeNamedNodeMap *(*notations) (GdomeDocumentType *self);
};

struct _GdomeElementVtab {
  GdomeNodeVtab super;
  GdomeDOMString *(*tagName) (GdomeElement *self);
  GdomeDOMString *(*getAttribute) (GdomeElement *self, GdomeDOMString *name);
  void (*setAttribute) (GdomeElement *self, GdomeDOMString *name, GdomeDOMString *value);
  void (*removeAttribute) (GdomeElement *self, GdomeDOMString *name);
  GdomeAttr *(*getAttributeNode) (GdomeElement *self, GdomeDOMString *name);
  GdomeAttr *(*setAttributeNode) (GdomeElement *self, GdomeAttr *newAttr);
  GdomeAttr *(*removeAttributeNode) (GdomeElement *self, GdomeAttr *oldAttr);
  GdomeNodeList *(*getElementsByTagName) (GdomeElement *self, GdomeDOMString *name);
  void (*normalize) (GdomeElement *self);
};

struct _GdomeEntityVtab {
  GdomeNodeVtab super;
  GdomeDOMString *(*publicId) (GdomeEntity *self);
  GdomeDOMString *(*systemId) (GdomeEntity *self);
  GdomeDOMString *(*notationName) (GdomeEntity *self);
};

struct _GdomeEntityReferenceVtab {
  GdomeNodeVtab super;
};

struct _GdomeNamedNodeMapVtab {
  void (*unref) (GdomeNamedNodeMap *self);
  GdomeNode *(*getNamedItem) (GdomeNamedNodeMap *self, GdomeDOMString *name);
  GdomeNode *(*setNamedItem) (GdomeNamedNodeMap *self, GdomeNode *arg);
  GdomeNode *(*removeNamedItem) (GdomeNamedNodeMap *self, GdomeDOMString *name);
  GdomeNode *(*item) (GdomeNamedNodeMap *self, unsigned long index);
  unsigned long (*length) (GdomeNamedNodeMap *self);
};

struct _GdomeNodeListVtab {
  void (*unref) (GdomeNodeList *self);
  GdomeNode *(*item) (GdomeNodeList *self, unsigned long index);
  unsigned long (*length) (GdomeNodeList *self);
};

struct _GdomeNotationVtab {
  GdomeNodeVtab super;
  GdomeDOMString *(*publicId) (GdomeNotation *self);
  GdomeDOMString *(*systemId) (GdomeNotation *self);
};

struct _GdomeParserVtab {
  void (*unref) (GdomeParser *self);
  GdomeDocument *(*xmlParseFile) (GdomeParser *self, GdomeDOMString *filename);
  GdomeDocument *(*xmlParseDoc) (GdomeParser *self, GdomeDOMString *content);
};

struct _GdomeProcessingInstructionVtab {
  GdomeNodeVtab super;
  GdomeDOMString *(*target) (GdomeProcessingInstruction *self);
  GdomeDOMString *(*data) (GdomeProcessingInstruction *self);
  void (*set_data) (GdomeProcessingInstruction *self, GdomeDOMString *data);
};

void gdome_str_unref (GdomeDOMString *self);

void gdome_n_unref (GdomeNode *self);
GdomeDOMString *gdome_n_nodeName (GdomeNode *self);
GdomeDOMString *gdome_n_nodeValue (GdomeNode *self);
void gdome_n_set_nodeValue (GdomeNode *self, GdomeDOMString *nodeValue);
unsigned short gdome_n_nodeType (GdomeNode *self);
GdomeNode *gdome_n_parentNode (GdomeNode *self);
GdomeNodeList *gdome_n_childNodes (GdomeNode *self);
GdomeNode *gdome_n_firstChild (GdomeNode *self);
GdomeNode *gdome_n_lastChild (GdomeNode *self);
GdomeNode *gdome_n_previousSibling (GdomeNode *self);
GdomeNode *gdome_n_nextSibling (GdomeNode *self);
GdomeNamedNodeMap *gdome_n_attributes (GdomeNode *self);
GdomeDocument *gdome_n_ownerDocument (GdomeNode *self);
GdomeNode *gdome_n_insertBefore (GdomeNode *self, GdomeNode *newChild, GdomeNode *refChild);
GdomeNode *gdome_n_replaceChild (GdomeNode *self, GdomeNode *newChild, GdomeNode *oldChild);
GdomeNode *gdome_n_removeChild (GdomeNode *self, GdomeNode *oldChild);
GdomeNode *gdome_n_appendChild (GdomeNode *self, GdomeNode *newChild);
GdomeBoolean gdome_n_hasChildNodes (GdomeNode *self);
GdomeNode *gdome_n_cloneNode (GdomeNode *self, GdomeBoolean deep);

GdomeDOMString *gdome_a_name (GdomeAttr *self);
GdomeBoolean gdome_a_specified (GdomeAttr *self);
GdomeDOMString *gdome_a_value (GdomeAttr *self);
void gdome_a_set_value (GdomeAttr *self, GdomeDOMString *value);

GdomeDOMString *gdome_cd_data (GdomeCharacterData *self);
void gdome_cd_set_data (GdomeCharacterData *self, GdomeDOMString *data);
unsigned long gdome_cd_length (GdomeCharacterData *self);
GdomeDOMString *gdome_cd_substringData (GdomeCharacterData *self, unsigned long offset, unsigned long count);
void gdome_cd_appendData (GdomeCharacterData *self, GdomeDOMString *arg);
void gdome_cd_insertData (GdomeCharacterData *self, unsigned long offset, GdomeDOMString *arg);
void gdome_cd_deleteData (GdomeCharacterData *self, unsigned long offset, unsigned long count);
void gdome_cd_replaceData (GdomeCharacterData *self, unsigned long offset, unsigned long count, GdomeDOMString *arg);

GdomeText *gdome_t_splitText (GdomeText *self, unsigned long offset);

void gdome_domi_unref (GdomeDOMImplementation *self);
GdomeBoolean gdome_domi_hasFeature (GdomeDOMImplementation *self, GdomeDOMString *feature, GdomeDOMString *version);

GdomeDocumentType *gdome_doc_doctype (GdomeDocument *self);
GdomeDOMImplementation *gdome_doc_implementation (GdomeDocument *self);
GdomeElement *gdome_doc_documentElement (GdomeDocument *self);
GdomeElement *gdome_doc_createElement (GdomeDocument *self, GdomeDOMString *tagName);
GdomeDocumentFragment *gdome_doc_createDocumentFragment (GdomeDocument *self);
GdomeText *gdome_doc_createTextNode (GdomeDocument *self, GdomeDOMString *data);
GdomeComment *gdome_doc_createComment (GdomeDocument *self, GdomeDOMString *data);
GdomeCDATASection *gdome_doc_createCDATASection (GdomeDocument *self, GdomeDOMString *data);
GdomeProcessingInstruction *gdome_doc_createProcessingInstruction (GdomeDocument *self, GdomeDOMString *target, GdomeDOMString *data);
GdomeAttr *gdome_doc_createAttribute (GdomeDocument *self, GdomeDOMString *name);
GdomeEntityReference *gdome_doc_createEntityReference (GdomeDocument *self, GdomeDOMString *name);
GdomeNodeList *gdome_doc_getElementsByTagName (GdomeDocument *self, GdomeDOMString *tagname);

GdomeDOMString *gdome_dt_name (GdomeDocumentType *self);
GdomeNamedNodeMap *gdome_dt_entities (GdomeDocumentType *self);
GdomeNamedNodeMap *gdome_dt_notations (GdomeDocumentType *self);

GdomeDOMString *gdome_el_tagName (GdomeElement *self);
GdomeDOMString *gdome_el_getAttribute (GdomeElement *self, GdomeDOMString *name);
void gdome_el_setAttribute (GdomeElement *self, GdomeDOMString *name, GdomeDOMString *value);
void gdome_el_removeAttribute (GdomeElement *self, GdomeDOMString *name);
GdomeAttr *gdome_el_getAttributeNode (GdomeElement *self, GdomeDOMString *name);
GdomeAttr *gdome_el_setAttributeNode (GdomeElement *self, GdomeAttr *newAttr);
GdomeAttr *gdome_el_removeAttributeNode (GdomeElement *self, GdomeAttr *oldAttr);
GdomeNodeList *gdome_el_getElementsByTagName (GdomeElement *self, GdomeDOMString *name);
void gdome_el_normalize (GdomeElement *self);

GdomeDOMString *gdome_ent_publicId (GdomeEntity *self);
GdomeDOMString *gdome_ent_systemId (GdomeEntity *self);
GdomeDOMString *gdome_ent_notationName (GdomeEntity *self);

void gdome_nnm_unref (GdomeNamedNodeMap *self);
GdomeNode *gdome_nnm_getNamedItem (GdomeNamedNodeMap *self, GdomeDOMString *name);
GdomeNode *gdome_nnm_setNamedItem (GdomeNamedNodeMap *self, GdomeNode *arg);
GdomeNode *gdome_nnm_removeNamedItem (GdomeNamedNodeMap *self, GdomeDOMString *name);
GdomeNode *gdome_nnm_item (GdomeNamedNodeMap *self, unsigned long index);
unsigned long gdome_nnm_length (GdomeNamedNodeMap *self);

void gdome_nl_unref (GdomeNodeList *self);
GdomeNode *gdome_nl_item (GdomeNodeList *self, unsigned long index);
unsigned long gdome_nl_length (GdomeNodeList *self);

GdomeDOMString *gdome_not_publicId (GdomeNotation *self);
GdomeDOMString *gdome_not_systemId (GdomeNotation *self);

void gdome_pars_unref (GdomeParser *self);
GdomeDocument *gdome_pars_xmlParseFile (GdomeParser *self, GdomeDOMString *filename);
GdomeDocument *gdome_pars_xmlParseDoc (GdomeParser *self, GdomeDOMString *content);

GdomeDOMString *gdome_pi_target (GdomeProcessingInstruction *self);
GdomeDOMString *gdome_pi_data (GdomeProcessingInstruction *self);
void gdome_pi_set_data (GdomeProcessingInstruction *self, GdomeDOMString *data);

